Search text and redact in JavaScript (ES5) PDF Viewer

3 Aug 20268 minutes to read

You can search for a keyword in the loaded PDF and automatically add redaction annotations over each match. The example below wires the extractTextCompleted event, triggers text extraction, performs a search, and places redaction annotations for every result.

NOTE

Prerequisites: Add the PDF Viewer control to your JavaScript application and ensure a document is loaded. Confirm the redaction feature is available in the viewer version in use and that text extraction is enabled (isExtractText: true). Redaction is permanent once applied.

Steps to add redaction annotations on search text bounds

Step 1: Follow the steps in PDF Viewer - Getting started to create a simple PDF Viewer sample.

Step 2: Use the following code-snippets to add Redaction annotation on search text bounds.

    <button id="searchTextRedact">Search Text and Redact</button>
    <button id="applyRedaction">Apply Redaction</button>
var pdfviewer = new ej.pdfviewer.PdfViewer({
    documentPath: 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
    resourceUrl: "https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib",
});

//Adding Redaction Tool in the toolbar
pdfviewer.toolbarSettings.toolbarItems = ['OpenOption', 'UndoRedoTool', 'PageNavigationTool', 'MagnificationTool', 'PanTool', 'SelectionTool', 'CommentTool', 'SubmitForm', 'AnnotationEditTool', 'RedactionEditTool', 'FormDesignerEditTool', 'SearchOption', 'PrintOption', 'DownloadOption'];

ej.pdfviewer.PdfViewer.Inject(ej.pdfviewer.TextSelection, ej.pdfviewer.TextSearch, ej.pdfviewer.Print, ej.pdfviewer.Navigation, ej.pdfviewer.Toolbar, ej.pdfviewer.Magnification, ej.pdfviewer.Annotation, ej.pdfviewer.FormDesigner, ej.pdfviewer.FormFields, ej.pdfviewer.PageOrganizer);

pdfviewer.appendTo('#PdfViewer');
//EventListener to Search Text and Redact  
document.getElementById('searchTextRedact').addEventListener('click', () => {
        // Function to handle extractTextCompleted event
        pdfviewer.extractTextCompleted = args => {
            const searchText = "syncfusion"; //Provide text to be redacted

            // Perform text search
            const searchResults = pdfviewer.textSearchModule.findText(searchText, false);

            if (!searchResults || searchResults.length === 0) {
                console.warn("No matches found.");
                return;
            }

            // Loop through search results
            for (let i = 0; i < searchResults.length; i++) {
                const pageResult = searchResults[i];
                if (!pageResult || !pageResult.bounds || pageResult.bounds.length === 0) { continue; }

                // guard pageIndex (fixes TS18048)
                if (pageResult.pageIndex == null) { continue; }
                const pageNumber = pageResult.pageIndex + 1;

                // Loop through each bounding box of the found text
                for (let j = 0; j < pageResult.bounds.length; j++) {
                    const bound = pageResult.bounds[j];

                    // Add a redaction annotation at the found text location
                    pdfviewer.annotation.addAnnotation("Redaction", {
                        bound: {
                            x: (bound.x * 96) / 72,
                            y: (bound.y * 96) / 72,
                            width: (bound.width * 96) / 72,
                            height: (bound.height * 96) / 72
                        },
                        pageNumber: pageNumber,
                        overlayText: "Confidential",
                        fillColor: "#00FF40FF",
                        fontColor: "#333333",
                        fontSize: 12,
                        fontFamily: "Arial",
                        // removed textAlign property (fixes TS2353)
                        markerFillColor: "#FF0000",
                        markerBorderColor: "#000000"
                    });
                }
            }
        };
    });

//EventListener to Apply Redaction
document.getElementById("applyRedaction")?.addEventListener('click', ()=>{
    pdfviewer.annotation.redact();
});

View Sample in GitHub

Notes

  • Ensure the PDF is fully loaded before triggering extraction and search.
  • Bounds from search are in points (72 DPI). Convert to pixels (96 DPI) to align with annotation coordinates.
  • Customize overlay text, colors, and typography as needed.
  • Adding a redaction annotation covers the content visually. To permanently remove sensitive data, use the viewer’s Apply Redaction action or equivalent API if available in your version.

See also

How to search text and redact in React PDF Viewer

23 Jul 202611 minutes to read

Overview

This guide shows how to search for text inside a loaded PDF and add redaction annotations programmatically for every match. You will add two buttons: one to locate and mark matches with redaction annotations, and another to apply redactions (permanently remove the marked content).

Outcome: After following the steps you will have a working React sample where clicking “Search & Mark for Redaction” marks found text with redaction annotations and clicking “Apply Redaction” permanently removes the marked content.

Prerequisites

  • EJ2 React PDF Viewer added to your project. See getting started guide.
  • The viewer’s redaction feature enabled in your product version.

Steps

  1. Create a React component that includes the PdfViewerComponent and Inject required services.
  2. Add two buttons: one to perform the text search and add redaction annotations, and one to apply redactions.
  3. Use the viewer’s findTextAsync() to get match bounds (returned in points), convert those bounds to pixels, and add a Redaction annotation for each bound using addAnnotation('Redaction', ...).
  4. Call redact() to apply redactions permanently when the user confirms.

Complete runnable example

import * as React from 'react';
import './index.css';
import {
    PdfViewerComponent, Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView, ThumbnailView, Print, TextSelection, Annotation, TextSearch, FormFields, FormDesigner, Inject, ToolbarItem
} from '@syncfusion/ej2-react-pdfviewer';

export default function App() {
    const viewerRef = React.useRef(null);
    const toolbarSettings = {
        toolbarItems: [
            'OpenOption',
            'UndoRedoTool',
            'PageNavigationTool',
            'MagnificationTool',
            'PanTool',
            'SelectionTool',
            'CommentTool',
            'SubmitForm',
            'AnnotationEditTool',
            'RedactionEditTool',
            'FormDesignerEditTool',
            'SearchOption',
            'PrintOption',
            'DownloadOption'
        ] as ToolbarItem[]
    };
    const px = (pt: number): number => (pt * 96) / 72;

    const searchTextAndRedact = async () => {
        if (!viewerRef.current || !viewerRef.current.textSearchModule) return;
        const term = 'syncfusion'; // change to the term you want to redact
        const results = await viewerRef.current.textSearchModule.findTextAsync(term, false);
        if (!results || results.length === 0) {
            console.warn('No matches found.');
            return;
        }

        for (const pageResult of results) {
            if (!pageResult?.bounds?.length) continue;
            const pageNumber = (pageResult.pageIndex ?? -1) + 1; // convert 0-based to 1-based
            if (pageNumber < 1) continue;

            for (const bound of pageResult.bounds) {
                viewerRef.current.annotation.addAnnotation('Redaction', {
                    bound: {
                        x: px(bound.x),
                        y: px(bound.y),
                        width: px(bound.width),
                        height: px(bound.height)
                    },
                    pageNumber,
                    overlayText: 'Confidential',
                    fillColor: '#000000',
                    fontColor: '#FFFFFF',
                    fontSize: 12,
                    fontFamily: 'Arial'
                });
            }
        }
    };

    const applyRedaction = () => {
        if (!viewerRef.current || !viewerRef.current.annotation) return;
        // This permanently removes content marked by redaction annotations
        viewerRef.current.annotation.redact();
    };

    return (
        <div className='content-wrapper' style={{ padding: 12 }}>
            <div style={{ marginBottom: 12, display: 'flex', gap: 8 }}>
                <button id='searchTextRedact' type='button' onClick={searchTextAndRedact}>
                    Search "syncfusion" & Mark for Redaction
                </button>
                <button id='applyRedaction' type='button' onClick={applyRedaction}>
                    Apply Redaction
                </button>
            </div>

            <PdfViewerComponent
                ref={viewerRef}
                id='container'
                documentPath='https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf'
                resourceUrl='https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib'
                toolbarSettings={toolbarSettings}
                isExtractText={true}
                style={{ height: '640px', display: 'block' }}
            >
                <Inject services={[
                    Toolbar,
                    Magnification,
                    Navigation,
                    Annotation,
                    LinkAnnotation,
                    BookmarkView,
                    ThumbnailView,
                    Print,
                    TextSelection,
                    TextSearch,
                    FormFields,
                    FormDesigner
                ]} />
            </PdfViewerComponent>
        </div>
    );
}

Expected result

  • The viewer loads the specified PDF.
  • Clicking “Search "syncfusion" & Mark for Redaction” adds redaction annotations over the matched text.
  • Clicking “Apply Redaction” permanently removes the marked content from the document; this operation is irreversible.

Troubleshooting

  • Issue: “No matches found” even though text exists — Cause: PDF text extraction may not be ready. Solution: Wait for the document to finish loading or call search after the documentLoad event.
  • Issue: Bounds look misplaced — Cause: findTextAsync() returns bounds in points (72 DPI). Ensure conversion to pixels using the provided px() helper.
  • Issue: textSearchModule is undefined — Cause: TextSearch service not injected. Add TextSearch to the Inject services list.
  • Issue: Redactions not applied — Cause: redact() requires redaction annotations present and viewer to support apply-redaction; ensure Annotation service and Redaction features are available in your build.

Search text and redact in Vue PDF Viewer

28 Feb 20268 minutes to read

You can search for a keyword in the loaded PDF and automatically add redaction annotations over each match. The example below wires the extractTextCompleted event, triggers text extraction, performs a search, and places redaction annotations for every result.

NOTE

Prerequisites: Add the PDF Viewer control to your Vue application and ensure a document is loaded. Confirm the redaction feature is available in the viewer version in use and that text extraction is enabled (isExtractText: true). Redaction is permanent once applied.

Steps to add redaction annotations on search text bounds

Step 1: Follow the steps in PDF Viewer - Getting started to create a simple PDF Viewer sample.

Step 2: Use the following code snippets to add redaction annotations to search text bounds.

<template>
  <div class="content-wrapper">
    <div style="margin-bottom: 8px; display: flex; gap: 8px; align-items: center;">
      <button id="searchTextRedact" type="button" @click="searchTextAndRedact">
        Search "syncfusion" & Mark for Redaction
      </button>
      <button id="applyRedaction" type="button" @click="applyRedaction">
        Apply Redaction
      </button>
    </div>

    <ejs-pdfviewer
      ref="pdfviewer"
      id="container"
      :documentPath="documentPath"
      :resourceUrl="resourceUrl"
      :toolbarSettings="toolbarSettings"
      :isExtractText="true"
      style="height: 640px; display: block;"
    />
  </div>
</template>

<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  LinkAnnotation,
  BookmarkView,
  ThumbnailView,
  Print,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  name: 'App',
  components: { 'ejs-pdfviewer': PdfViewerComponent },
  data() {
    return {
      documentPath: 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib',
      toolbarSettings: {
        toolbarItems: [
          'OpenOption',
          'UndoRedoTool',
          'PageNavigationTool',
          'MagnificationTool',
          'PanTool',
          'SelectionTool',
          'CommentTool',
          'SubmitForm',
          'AnnotationEditTool',
          'RedactionEditTool',
          'FormDesignerEditTool',
          'SearchOption',
          'PrintOption',
          'DownloadOption'
        ]
      }
    };
  },
  provide: {
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      Annotation,
      LinkAnnotation,
      BookmarkView,
      ThumbnailView,
      Print,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer
    ]
  },
  methods: {
    px(pt) {
      return (pt * 96) / 72; // points -> pixels
    },
    async searchTextAndRedact() {
      const inst = this.$refs.pdfviewer?.ej2Instances;
      if (!inst) return;
      const term = 'syncfusion';
      const results = await inst.textSearchModule.findTextAsync(term, false);
      if (!results || results.length === 0) {
        console.warn('No matches found.');
        return;
      }
      for (const pageResult of results) {
        if (!pageResult?.bounds?.length) continue;
        const pageNumber = (pageResult.pageIndex ?? -1) + 1; // 1-based
        if (pageNumber < 1) continue;
        for (const bound of pageResult.bounds) {
          inst.annotation.addAnnotation('Redaction', {
            bound: {
              x: this.px(bound.x),
              y: this.px(bound.y),
              width: this.px(bound.width),
              height: this.px(bound.height)
            },
            pageNumber,
            overlayText: 'Confidential',
            fillColor: '#00FF40FF',
            fontColor: '#333333',
            fontSize: 12,
            fontFamily: 'Arial',
            markerFillColor: '#FF0000',
            markerBorderColor: '#000000'
          });
        }
      }
    },
    applyRedaction() {
      const inst = this.$refs.pdfviewer?.ej2Instances;
      if (!inst) return;
      inst.annotation.redact();
    }
  }
};
</script>

View Sample in GitHub

Notes

  • Ensure the PDF is fully loaded before triggering extraction and search.
  • Bounds from search are in points (72 DPI). Convert to pixels (96 DPI) to align with annotation coordinates.
  • Customize overlay text, colors, and typography as needed.
  • Adding a redaction annotation covers the content visually. To permanently remove sensitive data, use the viewer’s Apply Redaction action or equivalent API if available in your version.

See also

Search text and redact in Angular PDF Viewer

11 Feb 20267 minutes to read

You can search for a keyword in the loaded PDF and automatically add redaction annotations over each match. The example below wires the extractTextCompleted event, triggers text extraction, performs a search, and places redaction annotations for every result.

NOTE

Prerequisites: Add the PDF Viewer control to your Angular application and ensure a document is loaded. Confirm the redaction feature is available in the viewer version in use and that text extraction is enabled (isExtractText: true). Redaction is permanent once applied.

Steps to add redaction annotations on search text bounds

Step 1: Follow the steps in PDF Viewer - Getting started to create a simple PDF Viewer sample.

Step 2: Use the following code snippets to add redaction annotations to search text bounds.

import { Component, ViewChild } from '@angular/core';
import {
  PdfViewerComponent,
  LinkAnnotationService,
  BookmarkViewService,
  MagnificationService,
  ThumbnailViewService,
  ToolbarService,
  NavigationService,
  AnnotationService,
  TextSearchService,
  TextSelectionService,
  PrintService,
  FormFieldsService,
  FormDesignerService,
  PageOrganizerService,
  ToolbarSettingsModel
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  template: `
    <div class="content-wrapper">
      <div style="margin-bottom:8px;display:flex;gap:8px;align-items:center;">
        <button id="searchTextRedact" type="button" (click)="searchTextAndRedact()">
          Search "syncfusion" & Mark for Redaction
        </button>
        <button id="applyRedaction" type="button" (click)="applyRedaction()">
          Apply Redaction
        </button>
      </div>

      <ejs-pdfviewer
        #pdfviewer
        id="PdfViewer"
        [documentPath]="document"
        [resourceUrl]="resource"
        [toolbarSettings]="toolbarSettings"
        [isExtractText]="true"
        style="height:640px;display:block">
      </ejs-pdfviewer>
    </div>
  `,
  providers: [
    // Angular DI is the Angular equivalent of PdfViewer.Inject(...)
    LinkAnnotationService,
    BookmarkViewService,
    MagnificationService,
    ThumbnailViewService,
    ToolbarService,
    NavigationService,
    AnnotationService,
    TextSearchService,
    TextSelectionService,
    PrintService,
    FormFieldsService,
    FormDesignerService,
    PageOrganizerService
  ]
})
export class AppComponent {
  @ViewChild('pdfviewer', { static: true }) pdfViewer!: PdfViewerComponent;

  // Same sources as in your JS
  public document = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';
  public resource = 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib';

  // Primary toolbar including Redaction
  public toolbarSettings: ToolbarSettingsModel = {
    toolbarItems: [
      'OpenOption',
      'UndoRedoTool',
      'PageNavigationTool',
      'MagnificationTool',
      'PanTool',
      'SelectionTool',
      'CommentTool',
      'SubmitForm',
      'AnnotationEditTool',
      'RedactionEditTool',   // show Redaction entry in main toolbar
      'FormDesignerEditTool',
      'SearchOption',
      'PrintOption',
      'DownloadOption'
    ]
  };

  /**
   * Finds the term "syncfusion" across the document and adds Redaction annotations
   * on top of every match (converts 72-dpi bounds to 96-dpi for addAnnotation).
   */
  async searchTextAndRedact(): Promise<void> {
    const term = 'syncfusion';
    // Use async search so we don't depend on extractTextCompleted timing.
    const results = await this.pdfViewer.textSearchModule.findTextAsync(term, false);
    if (!results || results.length === 0) {
      console.warn('No matches found.');
      return;
    }

    const px = (pt: number) => (pt * 96) / 72; // convert from points to pixels

    for (const pageResult of results) {
      if (!pageResult || !pageResult.bounds || pageResult.bounds.length === 0) { continue; }
      if (pageResult.pageIndex == null) { continue; } // guard
      const pageNumber = pageResult.pageIndex + 1;     // API expects 1-based

      for (const bound of pageResult.bounds) {
        this.pdfViewer.annotation.addAnnotation('Redaction', {
          bound: {
            x: px(bound.x),
            y: px(bound.y),
            width: px(bound.width),
            height: px(bound.height)
          },
          pageNumber,
          overlayText: 'Confidential',
          fillColor: '#00FF40FF',
          fontColor: '#333333',
          fontSize: 12,
          fontFamily: 'Arial',
          markerFillColor: '#FF0000',
          markerBorderColor: '#000000'
        } as any); // 'as any' to accept redaction-specific options
      }
    }
  }

  /** Permanently applies all redaction marks in the document. */
  applyRedaction(): void {
    this.pdfViewer.annotation.redact();
  }
}

View Sample in GitHub

Notes

  • Ensure the PDF is fully loaded before triggering extraction and search.
  • Bounds from search are in points (72 DPI). Convert to pixels (96 DPI) to align with annotation coordinates.
  • Customize overlay text, colors, and typography as needed.
  • Adding a redaction annotation covers the content visually. To permanently remove sensitive data, use the viewer’s Apply Redaction action or equivalent API if available in your version.

See also